



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>C++对象模型的那些事儿之三：默认构造函数</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">C++对象模型的那些事儿之三：默认构造函数</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-13 18:47:17 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<div>
<h1>前言</h1>
<p>继前两篇总结了C++对象模型及其内存布局后，我们继续来探索一下C++对象的默认构造函数。对于C++的初学者来说，有如下两个误解：</p>
<ul><li>任何class如果没有定义default constructor，就会被合成出来</li>
<li>编译器合成出来的default constructor会显示设定“class内每一个data member的默认值“</li></ul>
<p>如果读者对这两句话理解颇深，了解里面的陷阱，那么可以不必阅读下去；倘若你有一点点疑惑，那非常好，跟着我一起继续下去！</p>
<h1>无用(trivial)的构造函数</h1>
<p>一如前两篇的风格，先以一个例子来抛出一些疑惑，让读者带着问题来阅读，想来会事半功倍。如下面的程序代码，我定义了一个Cat类，里面包含两个参数，一个int型变量age和一个char型指针name。</p>
<pre class="prettyprint linenums"><code>class Cat{
public:
    int age;
    char* name;
};</code></pre>
<p>然后，在运行如下的测试代码：</p>
<pre class="prettyprint linenums"><code>int main(){
    Cat cat;
    cout&lt;&lt;“age=”&lt;&lt;cat.age&lt;&lt;endl;
    cout&lt;&lt;"name="&lt;&lt;(long long*)cat.name&lt;&lt;endl;
}</code></pre>
<p>上述测试代码输出如下：</p>
<pre class="prettyprint linenums"><code>age=4196864
name=0x400800</code></pre>
<p>我们来看看输出，age和name输出的都是一些随机值。在分析输出之前，先理解如下两个概念</p>
<ul><li>”程序员的需要“：程序员希望默认的构造函数能初始化类实例中所有的data members</li>
<li>“编译器的需要”：保证在创建类的实例的时候，存在一个构造函数，使得实例能创建，程序能正常运行。</li></ul>
<p>如果按照程序员的需要，age和name会被初始化，可是编译器并没有那么智能，猜不透程序员的想法，它给定的输出就是一堆随机值。</p>
<p>类似于这种编译器并没有按照”程序员的需要“对每个成员变量进行初始化，而是仅仅满足了”编译器的需要“，而默认生成的构造函数就被称为trivial constructor。</p>
<p>那么，编译器会在什么时候能按照”程序员的需要“，对类里面的data members初始化呢？请继续往下看。</p>
<h1>有用(non-trivial)的构造函数</h1>
<p>所谓的non-trivial constructor就是：编译器在合成构造函数的时候会对类中的data mambers初始化，从而满足”程序员的需求”。还是那个疑问，什么时候编译器会自动合成一个这样的构造函数呢？下面分四种情况来一一说明。</p>
<h2>带有默认构造函数的成员类对象</h2>
<p>如果一个类没有任何constructor，但它内含一个member object，后者还有一个default constructor，那么，编译器就会自动合成一个non-trivial constructor函数，不过这个合成操作只有在构造函数真正需要被调用的时候才合成。观察以下代码：</p>
<pre class="prettyprint linenums"><code>class Cat{
public:
    Cat():age(0){
        cout&lt;&lt;"Cat has been initialized"&lt;&lt;endl;
    }
    int age;
};
class Animal{
public:
    Cat cat;
};
int main(){
    Animal animal;
}</code></pre>
<p>在Animal类中声明了一个Cat实例，Cat类中有自己的空构造函数。接着我们可以运行一下这段代码，输出如下：</p>
<pre class="prettyprint linenums"><code>Cat has been initialized //cat类对象被构造</code></pre>
<p>从输出中可以看出，我们在main函数中声明了一个animal实例，然后animal类构造出了cat实例。可见，如果类的成员有其默认的构造函数，编译器就会合成一个non-trivial constructor，合成的空构造函数应该如下所示：</p>
<pre class="prettyprint linenums"><code>Animal(){
    Cat::Cat();
}</code></pre>
<p>如果一个类内含一个或多个成员类对象，那么编译器为这个类合成的默认构造函数会一次调用成员类的空构造函数，其调用顺序是声明顺序决定的。那么，如果类自己定义了空的构造函数怎么办？很简单，编译器会将这些成员类的构造代码安插在空构造函数里面，其摆放顺序也是按照声明顺序。</p>
<p>如以下测试代码：</p>
<pre class="prettyprint linenums"><code>class Dog{
public:
    Dog(){
        cout&lt;&lt;"Dog has been initialized"&lt;&lt;endl;
    }
};
class Cat{
public:
    Cat():age(0){
        cout&lt;&lt;"Cat has been initialized"&lt;&lt;endl;
    }
    int age;
};
class Animal{
public:
    Animal(){weight=0;}//按照声明顺序，cat和dog的构造会在weight之前
    Cat cat;
    Dog dog;
    int weight;
};
int main(){
    Animal animal;
}</code></pre>
<p>该测试代码的输出如下：</p>
<pre class="prettyprint linenums"><code>Cat has been initialized //先构造cat类对象，因为声明顺序在前
Dog has been initialized //再构造dog类对象</code></pre>
<h2>带有默认构造函数的基类</h2>
<p>如果一个派生类没有任何自定义构造函数，但它的基类有默认的构造函数，那么派生类中默认合成的构造函数中会安插基类的构造函数代码（按照声明顺序）。</p>
<p>如下例所示：</p>
<pre class="prettyprint linenums"><code>class Animal{
public:
    Animal(){
        cout&lt;&lt;"Animal has been initialized"&lt;&lt;endl;
    }
};

class Cat : public Animal{
public:

};
int main(){
    Cat cat;
}</code></pre>
<p>输出如下：</p>
<pre class="prettyprint linenums"><code>Animal has been initialized //父类构造函数的输出</code></pre>
<p>输出结果显示子类合成的构造函数调用了父类的空构造函数。在继承关系中，我们知道构造顺序是先构造父类，如果有多个父类就按照声明的继承顺序依次构造，然后在构造子类。编译器在父类拥有空构造函数的情况下，会合成一个non-trivial constructor并在里面按顺序安插父类的空构造函数调用代码。</p>
<p>那如果子类声明了多个构造函数，唯独没有空构造函数怎么办呢？编译器会合成一个空的构造函数吗？答案是否定的，编译器不会为它合成空构造函数，而是将父类的构造函数或者类对象的空构造函数依次安插在每个声明的构造函数内。</p>
<p>上面一堆话可能比较绕口，举个小例子就很好理解了，请看下面的代码：</p>
<pre class="prettyprint linenums"><code>class Dog{
public:
    Dog(){
        cout&lt;&lt;"Dog has been initialized"&lt;&lt;endl;
    }
};

class Animal{
public:
    Animal(){
        cout&lt;&lt;"Animal has been initialized"&lt;&lt;endl;
    }
};

class Cat : public Animal{//Cat类继承于Animal类，并在类里面声明了dog类的实例
public:
    Dog dog;
    Cat(int a){//Cat类里面没有空构造函数
        age = a;
    }
private:
    int age;
};

int main(){
    //Cat cat;  //如果这样写的话，编译器会报错，因为编译器根本没有为Cat类合成空构造函数
    Cat cat(1);
}</code></pre>
<p>上述代码的输出如下：</p>
<pre class="prettyprint linenums"><code>Animal has been initialized  //先构造基类
Dog has been initialized    //再构造类中声明的类对象</code></pre>
<p>所以，我们可以理一下编译器安插的构造函数的顺序：</p>
<ul><li>如果有基类，且基类有空构造函数，就按照基类的继承顺序依次构造</li>
<li>如果声明的成员变量有空构造函数，就按照声明顺序依次构造</li></ul>
<h2>带有一个虚函数的类</h2>
<p>在<a href="http://zcheng.ren/2016/08/06/%E3%80%90C++%E5%AD%A6%E4%B9%A0%E3%80%91C++%E5%AF%B9%E8%B1%A1%E6%A8%A1%E5%9E%8B%E7%9A%84%E9%82%A3%E4%BA%9B%E4%BA%8B%E5%84%BF%EF%BC%88%E4%B8%80%EF%BC%89/" rel="external nofollow noreferrer">C++对象模型的那些事儿(一)</a>中讲到，如果类含有虚函数，那么编译器会生成一个虚指针，虚指针指向含有虚函数地址的虚表。因此，如果一个类还有虚函数的话，那么编译器自然会生成一个空的构造函数，用来初始化虚指针。</p>
<p>于是，下面两个扩张行动就会在编译期间发生：</p>
<ul><li>一个虚函数表会被编译器产生出来，里面存放这虚函数的地址</li>
<li>在每一个类对象中，一个额外的虚表指针会被编译器合成出来，其指向上述生成的虚表</li></ul>
<pre class="prettyprint linenums"><code>typedef void(*Func)(void);
class Animal{
public:
    virtual void eat(){
        cout&lt;&lt;"Animal eat"&lt;&lt;endl;
    }
};

int main(){
    Animal animal;//调用空构造函数
    Fun pfun1 = (Fun)*((long long*)*(long long*)(&amp;animal));
    pfun1();//执行函数，输出Animal eat
}</code></pre>
<p>在上例中，main函数中定义一个Animal类的对象animal，调用了编译器合成的空构造函数，接下来我们通过强制类型转换，首先提取虚表指针的地址，然后提取虚表的地址，将虚表的第一个函数赋给一个函数指针，最后运行该函数，输出Animal eat。因此，编译器确实按照上述两个步骤合成了一个non-trivial的空构造函数。</p>
<h2>带有一个虚基类的子类</h2>
<p>虚基类的实现方法有点复杂，我们首先来看看下面这个例子：</p>
<pre class="prettyprint linenums"><code>class Animal{
public:
    int weight;
};

class Livestock : public virtual Animal{
public:
    int color;
};

class Canidae : public virtual Animal{
public:
    int age;
};
class WatchDog :  public  Canidae , public  Livestock{
public:
    int breed;
};</code></pre>
<p>其中，Animal是一个基类，Livestock和Candiae类虚继承于Animal类，WatchDog类继承于Livestock和Candiae类。基于上述继承关系，我们执行一下测试代码；</p>
<pre class="prettyprint linenums"><code>void setWeight(const Animal* a){//运行时绑定。在编译期间无法决定a-&gt;Animal::weight的位置
    a-&gt;weight = 100;
}
int main(){
    setWeight(new Livestock);
    setWeight(new WatchDog);
}</code></pre>
<p>针对上述测试代码，编译器无法固定setWeight()中的a-&gt;weight的实际偏移位置，因为a的真正类型都没有确定，所以必须是在确定传入的指针类型之后才能确定，也称为运行时绑定。</p>
<p>所有经由引用或者指针来存取一个虚基类的操作都可以通过指针来完成，那么，这个虚基类中weight变量的位置是如何确定的呢？想必你心里已有答案，没错</p>
<ul><li>对于类中所有定义的每一个构造函数，编译器会安插那些“允许每一个虚基类的执行器存取操作”（如上述的a-&gt;weight）的代码</li>
<li>如果类没有任何构造函数，编译器必须为其合成一个空构造函数</li></ul>
<h1>总结&amp;结束语</h1>
<p>本文通过测试代码一一测试了编译器在什么时候会产生trivial和non-trivial构造函数。现做如下整理。</p>
<p>生成non-trivial构造函数的情况：</p>
<ul><li>带有默认构造函数的成员类对象</li>
<li>带有默认构造函数的基类</li>
<li>带由虚函数的类</li>
<li>带有虚基类的类</li></ul>
<p>除这四种情况外，并且没有声明任何构造函数的类，编译器会在“需要的时候”为其构造一个隐式的trivial构造函数，它们实际上并不会被合成出来。</p>
<blockquote><p>这里的“需要的时候”只需要用到空构造函数的时候，如调用空构造函数构造一个类对象。如果没有用到空构造函数的时候，是不会被合成出来的</p></blockquote>
<p>在合成的空构造函数中，只有基类子对象和成员类对象会被初始化。所有其他的nonstatic data member（如int,int*,int数组等）都不会被初始化。这些初始化虽然对程序而言或许有需要，但对编译器则非必要。</p>
<p>所以，请注意！如果你需要把某指针初始化为null这类操作，最好老老实实自己写构造函数来初始化，不要指向编译器能帮你干这些事！</p>
<p>现在！请回过头去看前言中的两句话，是不是突然就意识到没有一个是对的。</p>
<h1>About Me</h1>
<p>由于本人也是初学，在写作过程中，难免有错误的地方，读者如果发现，请在下面留言指出。</p>
<p>最后，如有疑惑或需要讨论的地方，可以联系我，联系方式见我的个人博客about页面，地址：<a href="http://zcheng.ren/about/" rel="external nofollow noreferrer">About Me</a>。</p>
<p>另外，本人的第一本gitbook书已整理完，关于leetcode刷题题解的，<a href="https://www.gitbook.com/book/zeecoders/one-day-one-leetcode/details" rel="external nofollow noreferrer">点此进入One day One Leetcode</a></p>
<p>欢迎持续关注！Thx！</p>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/g8ey05x9.html">&amp;quot&semi;&period;NET Compact Framework v2&period;0 could not be found&period;&amp;quot&semi;</a>
		</li>
						<li><a href="https://www.batexi.com/a/r93yjgr8.html">springmvc结合ajax实现跨域上传文件</a>
		</li>
						<li><a href="https://www.batexi.com/a/m96lvgn9.html">Git学习笔记（4）&mdash;&mdash;添加远程仓库，克隆远程库，以及库的推送</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qym4dmq.html">SpringMVC Controller介绍&lpar;转）</a>
		</li>
						<li><a href="https://www.batexi.com/a/wq10de08.html">android之网络操作&lpar;1&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/r930p6g9.html">IntelliJ IDEA（社区版）学习记录</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gm1vlz9.html">好玩的代码之C&plus;&plus;实现CPU满载</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ok3y2x9.html">Oracle表空间操作</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e17dmm9.html">Linux创建新用户以及useradd  adduser的区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/90vgk648.html">windows快捷键命令汇总整理</a>
		</li>
						<li><a href="https://www.batexi.com/a/93y7gdn8.html">教你做炫酷的碎片式图片切换 &lpar;canvas&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1k42k29.html">cin问题                                                    分类：            c&plus;&plus;             2014-08-02 21&colon;13    38人阅读    评论&lpar;0&rpar;    收藏</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwjex6k8.html">vue全局配置----小白基础篇</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4jyjneq.html">python学习第一次笔记</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r54o7dq.html">IO创建Socket通信中慎用BufferReader中的readLine&lpar;&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4jn545q.html">logstash配置白名单决定去哪个index</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gjg6o09.html">androidstudio项目如何使用git版本回退</a>
		</li>
						<li><a href="https://www.batexi.com/a/qllp3l0q.html">linux、centos下安装配置vim</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnv4o038.html">Go语言运算符</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zyxrx19.html">python棋类游戏编写入门</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/q7z1e7k9.html">Python 编程规范</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2j1xxv8.html">Linux学习之CentOS&lpar;十四）----磁盘管理之 硬连接与软件连接&lpar;转&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7z172x9.html">Spring &commat;Component的作用详细介绍</a>
			</li>
						<li><a href="https://www.batexi.com/a/8eyk02j9.html">MyBatis 传入参数之parameterType</a>
			</li>
						<li><a href="https://www.batexi.com/a/8me4d70q.html">&lpar;MariaDB&rpar;开窗函数用法</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7z1l2x9.html">struct2 拿到url的方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/8me4pv6q.html">android基础-界面开发注意事项</a>
			</li>
						<li><a href="https://www.batexi.com/a/90m5p1m8.html">迭代器&amp;amp&semi;生成器</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlj0kr69.html">Linux下常用的配置</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rgl7l78.html">ACM  数塔</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
